Bug 996042 - Review Request: tinyxml2 - Simple, small and efficient C++ XML parser
Review Request: tinyxml2 - Simple, small and efficient C++ XML parser
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Susi Lehtola
Fedora Extras Quality Assurance
: Reopened
Depends On:
Blocks: 991744
  Show dependency treegraph
 
Reported: 2013-08-12 05:50 EDT by François Cami
Modified: 2013-10-29 14:06 EDT (History)
4 users (show)

See Also:
Fixed In Version: tinyxml2-1.0.11-4.20130805git0323851.el5
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-10-29 14:06:35 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
susi.lehtola: fedora‑review+


Attachments (Terms of Use)
Patch to spec file to fix issues (540 bytes, patch)
2013-08-12 11:44 EDT, Susi Lehtola
no flags Details | Diff

  None (edit)
Description François Cami 2013-08-12 05:50:12 EDT
Spec URL: http://fcami.fedorapeople.org/srpms/tinyxml2.spec
SRPM URL: http://fcami.fedorapeople.org/srpms/tinyxml2-1.0.11-2.20130805git0323851.fc18.src.rpm
Description: TinyXML-2 is a simple, small, efficient, C++ XML parser that can be
easily integrated into other programs. It uses a Document Object Model
(DOM), meaning the XML data is parsed into a C++ objects that can be
browsed and manipulated, and then written to disk or another output stream. 

TinyXML-2 doesn't parse or use DTDs (Document Type Definitions) nor XSLs
(eXtensible Stylesheet Language). 

TinyXML-2 uses a similar API to TinyXML-1, But the implementation of the
parser was completely re-written to make it more appropriate for use in a
game. It uses less memory, is faster, and uses far fewer memory allocations.

Fedora Account System Username: fcami
Comment 1 Mario Ceresa 2013-08-12 06:03:24 EDT
Hello François, Susi,
I'm also interested in having tinyxml2 packaged: just tell me how I can be of help.

Best,

Mario
Comment 2 François Cami 2013-08-12 07:24:37 EDT
Builds in mock/rawhide/x86_64:
http://koji.fedoraproject.org/koji/taskinfo?taskID=5807662
Comment 3 Susi Lehtola 2013-08-12 11:38:47 EDT
The chmod belongs in %prep (after %setup), not %build.

**

The statement
 %cmake
should read
 %cmake .

I have no idea why it would even run without a path statement.

Also, I would *really* recommend using a clean buildroot, as CMake is a modern build system and supports out-of-root builds out of the box.

**

OT: I'm not quite sure why you'd want to explicitly state the minor soversion, because it isn't even used by the dependency checkers.


===== MUST items =====

C/C++:
[x]: Header files in -devel subpackage, if present.
[x]: ldconfig called in %post and %postun if required.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: %build honors applicable compiler flags or justifies otherwise.
[-]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[-]: Package requires other packages for directories it uses.
[x]: Package uses nothing in %doc for runtime.
[x]: Package is not known to require ExcludeArch.
[x]: Package complies to the Packaging Guidelines
[-]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: License field in the package spec file matches the actual license.
[-]: License file installed when any subpackage combination is installed.
[x]: Package consistently uses macro is (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[-]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[-]: Large documentation must go in a -doc subpackage.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Fully versioned dependency in subpackages, if present.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).

===== SHOULD items =====

Generic:
[!]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Scriptlets must be sane, if used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present.
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Uses parallel make.
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: SourceX tarball generation or download is documented.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define.

===== EXTRA items =====

Generic:
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).


Rpmlint
-------
Checking: tinyxml2-1.0.11-2.20130805git0323851.fc18.x86_64.rpm
          tinyxml2-devel-1.0.11-2.20130805git0323851.fc18.x86_64.rpm
tinyxml2.x86_64: W: spelling-error %description -l en_US eXtensible -> extensible
tinyxml2-devel.x86_64: W: no-documentation
2 packages and 0 specfiles checked; 0 errors, 2 warnings.

These are OK.


Rpmlint (installed packages)
----------------------------
# rpmlint tinyxml2 tinyxml2-devel
tinyxml2.x86_64: W: spelling-error %description -l en_US eXtensible -> extensible
tinyxml2.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libtinyxml2.so.1.0.11 /lib64/libm.so.6
tinyxml2-devel.x86_64: W: no-documentation
2 packages and 0 specfiles checked; 0 errors, 3 warnings.
# echo 'rpmlint-done:'


Please address the unused-direct-shlib-dependency issue.


Requires
--------
tinyxml2 (rpmlib, GLIBC filtered):
    /sbin/ldconfig
    libc.so.6()(64bit)
    libgcc_s.so.1()(64bit)
    libgcc_s.so.1(GCC_3.0)(64bit)
    libm.so.6()(64bit)
    libstdc++.so.6()(64bit)
    libstdc++.so.6(CXXABI_1.3)(64bit)
    rtld(GNU_HASH)

tinyxml2-devel (rpmlib, GLIBC filtered):
    /usr/bin/pkg-config
    libtinyxml2.so.1()(64bit)
    tinyxml2(x86-64)



Provides
--------
tinyxml2:
    libtinyxml2.so.1()(64bit)
    tinyxml2
    tinyxml2(x86-64)

tinyxml2-devel:
    pkgconfig(tinyxml2)
    tinyxml2-devel
    tinyxml2-devel(x86-64)



Source checksums
----------------
https://github.com/leethomason/tinyxml2/archive/03238517b3718f0c977bb061747faa8ebfc4fb44/tinyxml2-1.0.11-0323851.tar.gz :
  CHECKSUM(SHA256) this package     : b5c4df98b44919435451770504401a1d4887e5e81e720686a5077d823149fdab
  CHECKSUM(SHA256) upstream package : b5c4df98b44919435451770504401a1d4887e5e81e720686a5077d823149fdab
Comment 4 Susi Lehtola 2013-08-12 11:43:12 EDT
Also, you can avoid building the static library altogether with the argument
 -DBUILD_STATIC_LIBS=OFF 
to %cmake.
Comment 5 Susi Lehtola 2013-08-12 11:44:09 EDT
Created attachment 785763 [details]
Patch to spec file to fix issues
Comment 6 Susi Lehtola 2013-08-12 11:44:55 EDT
I'll trust you to apply the patch #785763 before git import.


The package has been

APPROVED

with comments.
Comment 7 François Cami 2013-08-12 18:14:09 EDT
Thank you Susi.
Comment 8 François Cami 2013-08-12 18:14:31 EDT
New Package SCM Request
=======================
Package Name: tinyxml2
Short Description: Simple, small and efficient C++ XML parser
Owners: fcami
Branches: f18 f19
InitialCC:
Comment 9 Susi Lehtola 2013-08-12 18:19:36 EDT
Could you do el5 and el6 as well? cppcheck needs them and this is a very simple package.
Comment 10 François Cami 2013-08-12 18:21:09 EDT
New Package SCM Request
=======================
Package Name: tinyxml2
Short Description: Simple, small and efficient C++ XML parser
Owners: fcami
Branches: el5 el6 f18 f19
InitialCC:
Comment 11 Gwyn Ciesla 2013-08-13 08:47:36 EDT
Git done (by process-git-requests).
Comment 12 François Cami 2013-08-13 16:36:59 EDT
Thank you Jon.
Comment 13 Fedora Update System 2013-08-13 17:22:43 EDT
tinyxml2-1.0.11-3.20130805git0323851.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/tinyxml2-1.0.11-3.20130805git0323851.fc18
Comment 14 Fedora Update System 2013-08-13 17:23:35 EDT
tinyxml2-1.0.11-3.20130805git0323851.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/tinyxml2-1.0.11-3.20130805git0323851.fc19
Comment 15 Fedora Update System 2013-08-14 22:42:06 EDT
tinyxml2-1.0.11-3.20130805git0323851.fc18 has been pushed to the Fedora 18 testing repository.
Comment 16 Fedora Update System 2013-08-22 20:35:31 EDT
tinyxml2-1.0.11-3.20130805git0323851.fc19 has been pushed to the Fedora 19 stable repository.
Comment 17 Fedora Update System 2013-08-22 20:40:05 EDT
tinyxml2-1.0.11-3.20130805git0323851.fc18 has been pushed to the Fedora 18 stable repository.
Comment 18 Susi Lehtola 2013-10-13 13:10:58 EDT
I need the EL branches for cppcheck. Comaintainers welcome.

Package Change Request
======================
Package Name: pkgname
New Branches: el5 el6
Owners: jussilehtola
Comment 19 Susi Lehtola 2013-10-13 13:11:31 EDT
Damn, too quick cut'n'paste.

Package Change Request
======================
Package Name: tinyxml2
New Branches: el5 el6
Owners: jussilehtola
Comment 20 Susi Lehtola 2013-10-14 04:15:16 EDT
Oh didn't notice the branches already exist, but there's nothing built..
Comment 21 François Cami 2013-10-14 04:23:45 EDT
IIRC it needs newer autotools than what we have in RHEL6.

A possible fix could be to install newer autotools over RHEL5/6 and then generate the necessary configuration, and include that in Fedora git. I still haven't had the time to try that (and do not even know if that's a way / the best way to do it) but you're certainly welcome if you do.
Comment 22 Fedora Update System 2013-10-14 04:39:56 EDT
tinyxml2-1.0.11-4.20130805git0323851.el6 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/tinyxml2-1.0.11-4.20130805git0323851.el6
Comment 23 Fedora Update System 2013-10-14 04:40:06 EDT
tinyxml2-1.0.11-4.20130805git0323851.el5 has been submitted as an update for Fedora EPEL 5.
https://admin.fedoraproject.org/updates/tinyxml2-1.0.11-4.20130805git0323851.el5
Comment 24 Fedora Update System 2013-10-14 12:08:04 EDT
tinyxml2-1.0.11-4.20130805git0323851.el5, cppcheck-1.62-1.el5 has been pushed to the Fedora EPEL 5 testing repository.
Comment 25 Fedora Update System 2013-10-29 14:06:35 EDT
tinyxml2-1.0.11-4.20130805git0323851.el6, cppcheck-1.62-1.el6 has been pushed to the Fedora EPEL 6 stable repository.
Comment 26 Fedora Update System 2013-10-29 14:06:53 EDT
tinyxml2-1.0.11-4.20130805git0323851.el5, cppcheck-1.62-1.el5 has been pushed to the Fedora EPEL 5 stable repository.

Note You need to log in before you can comment on or make changes to this bug.